VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cIcon"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' -------------------------------------------------------------------------------
' \\ - funciones para devolver un cono como un StdPicture, y otra funcin para dibujar un cono en un Hdc
' -------------------------------------------------------------------------------


Private Const LR_LOADFROMFILE               As Long = &H10
Private Const LR_LOADMAP3DCOLORS            As Long = &H1000
Private Const LR_SHARED                     As Long = &H8000&
Private Const IMAGE_ICON                    As Long = 1
Private Const IMAGE_BITMAP                  As Long = 0

'DrawIconEx constantes
Private Const DI_MASK           As Long = &H1
Private Const DI_IMAGE          As Long = &H2
Private Const DI_NORMAL         As Long = DI_MASK Or DI_IMAGE


Private Type RECT
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type

Private Type SHFILEINFO
   hIcon          As Long
   iIcon          As Long
   dwAttributes   As Long
   szDisplayName  As String * 260
   szTypeName     As String * 80
End Type

Enum eSizeIcon
    [eSmall] = 257
    [enormal] = 256
End Enum
Private Type IconType
  cbSize As Long
  picType As PictureTypeConstants
  hIcon As Long
End Type

Private Type CLSIdType
  id(16) As Byte
End Type


Private Declare Function DrawIconEx Lib "user32.dll" (ByVal hdc As Long, ByVal xLeft As Long, ByVal yTop As Long, ByVal hIcon As Long, ByVal cxWidth As Long, ByVal cyWidth As Long, ByVal istepIfAniCur As Long, ByVal hbrFlickerFreeDraw As Long, ByVal diFlags As Long) As Long
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function OleTranslateColor Lib "oleaut32.dll" (ByVal lOleColor As Long, ByVal lHPalette As Long, lColorRef As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long

Private Declare Function CreateBitmap Lib "gdi32.dll" (ByVal nWidth As Long, ByVal nHeight As Long, ByVal nPlanes As Long, ByVal nBitCount As Long, ByRef lpBits As Any) As Long
Private Declare Function DeleteObject Lib "gdi32.dll" (ByVal hObject As Long) As Long
Private Declare Function SelectObject Lib "gdi32.dll" (ByVal hdc As Long, ByVal hObject As Long) As Long

Private Declare Function OleCreatePictureIndirect Lib "oleaut32.dll" (pDicDesc As IconType, riid As CLSIdType, ByVal fown As Long, lpUnk As Object) As Long
Private Declare Function SHGetFileInfo Lib "shell32.dll" Alias "SHGetFileInfoA" (ByVal pszPath As String, ByVal dwFileAttributes As Long, psfi As SHFILEINFO, ByVal cbFileInfo As Long, ByVal uFlags As Long) As Long

Private Declare Function DestroyIcon Lib "user32" (ByVal hIcon As Long) As Long
Private Declare Function LoadImage Lib "user32" Alias "LoadImageA" (ByVal hInst As Long, ByVal lpsz As String, ByVal dwImageType As Long, ByVal dwDesiredWidth As Long, ByVal dwDesiredHeight As Long, ByVal dwFlags As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32.dll" (ByVal hdc As Long) As Long

Private Declare Function FillRect Lib "user32.dll" (ByVal hdc As Long, ByRef lpRect As RECT, ByVal hBrush As Long) As Long

Private hBmp                    As Long
Private mWidthImage             As Integer
Private mHeightImage            As Integer

Property Get WidthImage() As Integer
    WidthImage = mWidthImage
End Property

Property Let WidthImage(iValue As Integer)
    mWidthImage = iValue
End Property

Property Get HeightImage() As Integer
    HeightImage = mHeightImage
End Property

Property Let HeightImage(iValue As Integer)
    mHeightImage = iValue
End Property

' --------------------------------------------------------------------------
' \\ Devolver cono - Como StdPic
' --------------------------------------------------------------------------
Function GetFileIcon(ByVal sPathFile As String, lSize As eSizeIcon) As IPictureDisp
  Dim ret As Long
  Dim Unkown As IUnknown
  Dim Icon As IconType
  Dim CLSID As CLSIdType
  Dim ShellInfo As SHFILEINFO
  
  Call SHGetFileInfo(sPathFile, 0, ShellInfo, Len(ShellInfo), lSize)
  
  With Icon
    .cbSize = Len(Icon)
    .picType = vbPicTypeIcon
    .hIcon = ShellInfo.hIcon
  End With
  
  With CLSID
    .id(8) = &HC0
    .id(15) = &H46
  End With
  
  ret = OleCreatePictureIndirect(Icon, CLSID, 1, Unkown)
  Set GetFileIcon = Unkown ' retornar la imagen
End Function

' --------------------------------------------------------------------------
' \\ Dibujar cono en un Hdc - Para los grficos de las pantallas
' --------------------------------------------------------------------------

Function DrawBitmapDC(sIconPath As String, lHdc As Long, x As Long, Y As Long, lWidth As Long, lHeight As Long, Optional lBackColorImage As Long = vbButtonFace) As Boolean
    Dim dcRect As RECT
    Dim mDC As Long
    Dim hIcon As Long
    
    If hBmp Then DeleteObject hBmp
    
    mDC = CreateCompatibleDC(0)
    hBmp = CreateBitmap(lWidth, lHeight, 1, 32, ByVal 0&)
    DeleteObject SelectObject(mDC, hBmp)
    
    With dcRect
        .Bottom = lHeight
        .Right = lWidth
    End With
    
    Dim lRet As Long
    
    hIcon = LoadImage(App.hInstance, sIconPath, IMAGE_ICON, lWidth, lHeight, LR_LOADFROMFILE)
    
    If hIcon Then
        lRet = FillRect(mDC, dcRect, CreateSolidBrush(TranslateColor(lBackColorImage)))
        lRet = DrawIconEx(mDC, 0, 0, hIcon, 0, 0, 0, 0, DI_NORMAL)
        Call DestroyIcon(hIcon)
    
        lRet = BitBlt(lHdc, x, Y, lWidth, lHeight, mDC, 0, 0, vbSrcCopy)
        Call DeleteDC(mDC)
        
        DrawBitmapDC = True
    End If
    
End Function


Private Function TranslateColor(ByVal clr As OLE_COLOR, Optional hPal As Long = 0) As Long
    If OleTranslateColor(clr, hPal, TranslateColor) Then
        TranslateColor = -1
    End If
End Function
